> For the complete documentation index, see [llms.txt](https://api.pyblish.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://api.pyblish.com/pluginsystem.md).

# Plug-in System

Learn about how things happen in Pyblish.

## Introduction

There are three ways in which a plug-in is associated with a particular set of data.

1. By availability
2. By host
3. By family

Availability is determined by registering a given plug-in to Pyblish, for example by calling [register\_plugin\_path()](https://github.com/pyblish/api/tree/9d41e509649f2dfb91bc4d595aebabed2dc0512f/pages/register_plugin_path.md). Once a plug-in is made available, it must also match the currently running host.

```python
class MyPlugin(...):
  hosts = ["maya"]
```

If the host matches, a plug-in is put to the final test; it's supported families.

```python
class MyPlugin(...):
  families = ["myFamily"]
```

**See also**

* [Plugin.hosts](/pyblish.api/plugin/plugin.hosts.md)

## Data

These data members are included.

| Data         | Description                                       |
| ------------ | ------------------------------------------------- |
| currentFile  | Current working file                              |
| workspaceDir | Higher-level directory of current file            |
| user         | Currently logged on user                          |
| cwd          | Current working directory (of Python interpreter) |

**Example**

```python
import pyblish.util
context = pyblish.util.collect()
print context.data["currentFile"]
```

\[2]: <https://github.com/pyblish/pyblish.api/wiki/Plugin.hosts>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://api.pyblish.com/pluginsystem.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
